//+------------------------------------------------------------------+
//|    _TRO_i-IntradayFibProj                  |
//|                                            |
//|                                            |
//|                                                                  |
//|                       |
//+------------------------------------------------------------------+
#property copyright "ATH"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Orange
#property indicator_color2 Orange
#property indicator_color3 Orange
#property indicator_color4 Orange

extern int NumberOfBars = 1000;  

//-------  ------------------------------------------

double bufRP1[];
double bufRP2[];
double bufSP1[];
double bufSP2[];
 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  SetIndexBuffer(0, bufRP2);
  SetIndexStyle (0, DRAW_LINE, STYLE_DOT);
  SetIndexEmptyValue(0, EMPTY_VALUE);

  SetIndexBuffer(1, bufRP1);
  SetIndexStyle (1, DRAW_LINE, STYLE_DOT);
  SetIndexEmptyValue(1, EMPTY_VALUE);

  SetIndexBuffer(2, bufSP1);
  SetIndexStyle (2, DRAW_LINE, STYLE_DOT);
  SetIndexEmptyValue(2, EMPTY_VALUE);

  SetIndexBuffer(3, bufSP2);
  SetIndexStyle (3, DRAW_LINE, STYLE_DOT);
  SetIndexEmptyValue(3, EMPTY_VALUE);

}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
  double dMax, dMin, dRange;
  int    loopbegin, nsb, prevDay, shift;

 	if (NumberOfBars==0) loopbegin = Bars - 1;
  else loopbegin = NumberOfBars - 1;

  for (shift=loopbegin; shift>=0; shift--) {
    if (prevDay!=TimeDay(Time[shift])) {
      nsb=iBarShift(NULL, PERIOD_D1, Time[shift+1]);
      dMax=iHigh(NULL, PERIOD_D1, nsb);
      dMin=iLow (NULL, PERIOD_D1, nsb);
      dRange=dMax-dMin;
    }
  
    bufRP2[shift]=dMax+(dRange*0.618);
    bufRP1[shift]=dMax+(dRange*0.382);
    bufSP1[shift]=dMin-(dRange*0.382);    
    bufSP2[shift]=dMin-(dRange*0.618);

    prevDay=TimeDay(Time[shift]);
  }
}
//+------------------------------------------------------------------+

