//+------------------------------------------------------------------+
//|    _TRO_i-IntradayFibonacci              i-IntradayFibonacci.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//| 14.10.2005                           |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Teal
#property indicator_color2 DarkKhaki
#property indicator_color3 DarkKhaki
#property indicator_color4 Teal
#property indicator_color5 Gray
#property indicator_color6 Blue
#property indicator_color7 Red



//-------   --------------------------------------

//-------    ---------------------------------

//-------    -------------------------------
extern int NumberOfBars = 1000;  //    (0-)

//-------   ------------------------------------------

double buf00[];
double buf24[];
double buf38[];
double buf50[];
double buf62[];
double buf76[];
double buf100[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  SetIndexBuffer(0, buf24);
  SetIndexStyle (0, DRAW_LINE, STYLE_DOT);
  SetIndexEmptyValue(0, EMPTY_VALUE);

  SetIndexBuffer(1, buf38);
  SetIndexStyle (1, DRAW_LINE, STYLE_DOT);
  SetIndexEmptyValue(1, EMPTY_VALUE);

  SetIndexBuffer(2, buf62);
  SetIndexStyle (2, DRAW_LINE, STYLE_DOT);
  SetIndexEmptyValue(2, EMPTY_VALUE);

  SetIndexBuffer(3, buf76);
  SetIndexStyle (3, DRAW_LINE, STYLE_DOT);
  SetIndexEmptyValue(3, EMPTY_VALUE);

  SetIndexBuffer(4, buf50);
  SetIndexStyle (4, DRAW_LINE, STYLE_DOT);
  SetIndexEmptyValue(4, EMPTY_VALUE);

  SetIndexBuffer(5, buf100);
  SetIndexStyle (5, DRAW_LINE, STYLE_DOT);
  SetIndexEmptyValue(5, EMPTY_VALUE);

  SetIndexBuffer(6, buf00);
  SetIndexStyle (6, DRAW_LINE, STYLE_DOT);
  SetIndexEmptyValue(6, EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
  double dMax, dMin;
  int    loopbegin, nsb, prevDay, shift;

 	if (NumberOfBars==0) loopbegin = Bars - 1;
  else loopbegin = NumberOfBars - 1;

  for (shift=loopbegin; shift>=0; shift--) {
    if (prevDay!=TimeDay(Time[shift])) {
      nsb=iBarShift(NULL, PERIOD_D1, Time[shift]);
      dMax=iHigh(NULL, PERIOD_D1, nsb);
      dMin=iLow (NULL, PERIOD_D1, nsb);
    }
    buf00[shift]=dMin;    
    buf24[shift]=dMin-(dMin-dMax)*0.236;
    buf38[shift]=dMin-(dMin-dMax)*0.382;
    buf50[shift]=dMin-(dMin-dMax)*0.500;    
    buf62[shift]=dMin-(dMin-dMax)*0.618;
    buf76[shift]=dMin-(dMin-dMax)*0.764;
    buf100[shift]= dMax;
    prevDay=TimeDay(Time[shift]);
  }
}
//+------------------------------------------------------------------+

